<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>MyTable</title>
</head>
<body>
    
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    
    <script>
        let myArray = [
            {'charityName':'Earth Trust', 'distance':30, 'total':23, 'year':'2008' },
            {'charityName':'Animal Trust', 'distance':32, 'total':54, 'year':'2005' },
            {'charityName':'Childrean Trust', 'distance':29, 'total':7, 'year':'2021' },
            {'charityName':'Culture Trust', 'distance':25, 'total':15, 'year':'2024' },
            {'charityName':'Inovation Trust', 'distance':'27', 'total':32, 'year':'2022' },
            {'charityName':'Active Trust', 'distance':24, 'total':6, 'year':'2000' },
            {'charityName':'Care Trust', 'distance':31, 'total':8, 'year':'2007' },
            {'charityName':'Education Trust', 'distance':2, 'total':46, 'year':'1999' },
            {'charityName':'Green Trust', 'distance':14, 'total':4, 'year':'2004' },
            {'charityName':'Global Trust', 'distance':29, 'total':65, 'year':'1998' },
            {'charityName':'Support Trust', 'distance':85, 'total':76, 'year':'1993' },
            {'charityName':'Community Trust', 'distance':81, 'total':73, 'year':'1996' },
        ]
    
    function buildTable(data){
        var table = document.getElementById('myTable')
        table.innerHTML = ''
        for (var i = 0; i < data.length; i++){
            let colname = `charityName-${i}`
            let colDistance = `distance-${i}`
            let colTotal = `total-${i}`
            let colYear= `year-${i}`
    
            let row = `<tr>
                            <td>${data[i].charityName}</td>
                            <td>${data[i].distance}</td>
                            <td>${data[i].total}</td>
                            <td>${data[i].year}</td>
                            
                       </tr>`
            table.innerHTML += row
        }
    }
    </script>

    <style>
        th{ 
            cursor: pointer;
            color:#fff;
            background-color: blue;
                }

                .myHeadings{
                    background-color: aquamarine;
                }

    </style>
        <div class="button-group">
            <button type="button" onclick="buildTable(myArray)" class="btn btn-info">search</button>

    <div class="myHeadings">
    <table class="table table-striped">
        <tr  class="bg-info">
            <th   data-colname="charityName" data-order="desc">charity Name&#9650</th>
            <th  data-colname="distance" data-order="desc">distance &#9650</th>
            <th  data-colname="total" data-order="desc">total &#9650</th>
        </div>
         <th  data-colname="year" data-order="desc">year &#9650</th>
        </tr>
    </div>

        <tbody id="myTable">
            
        </tbody>
    </table>
    
    <script>
            $('th').on('click', function(){
        console.log('click2')
         let column = $(this).data('colname')
         let order = $(this).data('order')
         let text = $(this).html()
         console.log('column was clicked', column, order) 
         text = text.substring(0, text.length - 1);
         
         
         
         if (order == 'desc'){
            myArray = myArray.sort((a, b) => a[column] > b[column] ? 1 : -1)
            $(this).data("order","asc");
            text += '&#9660'
         }else{
            myArray = myArray.sort((a, b) => a[column] < b[column] ? 1 : -1)
            $(this).data("order","desc");
            text += '&#9650'
         }
    
        $(this).html(text)  
        buildTable(myArray)
        })
    </script>
 
</body>
</html>